﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

Sub Class_Globals
	Private Root 			As B4XView
	Private xui 			As XUI
	Public 	SessionUID 		As String
	Public 	DomainPath 		As String
	Private btnDomainPath 	As Button
	Private btnDomainPathSession As Button
	
	Private btnCreateSession As Button
	Private btnRemoveSession As Button
	Private btnCheckSession As Button
	Private btnSendPostRequest As Button
End Sub

Public Sub Initialize
'	B4XPages.GetManager.LogEvents = True
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	
	' PLEASE NOTE
	' -----------
	' B4X Sessions module
	' Please add your contributions below to showcase new functionality and don't forget to comment your added methods.
	' Also increase LibraryVersion in #Region Project Attributes.
	' Use the GUI to add/show functionality whenever neccessary.
	
	' ------------------------------------------------------------------------------------------------------------------------
	' Choose type of ID generator:
	
		' Generate Unique user ID (ThRuST's version : 1627580073964893881104629331612202613825855710527480866101217920394995325)
		'B4XSessions.UID = B4XSessions.GenerateUID(SessionUID)
	
		' Generate Unique GUID (Erel's version : 055AF933-59E8-C059-7291-E3BA80BD9804)
		B4XSessions.UID = B4XSessions.GenerateGUID(SessionUID)
	
	' ------------------------------------------------------------------------------------------------------------------------
	' Displays Domain path
	Log("Domain:")
	Log(B4XSessions.Domain(DomainPath))
	Log(" ")
	
	' Display CookieFolder
	Log("CookieFolder:")
	Log(B4XSessions.CookieFolder)
	Log(" ")
	
	' Complete path to session cookie file
	Log("Domain, CookieFolder and UID:")
	Log(B4XSessions.Domain(DomainPath) & "/" & B4XSessions.CookieFolder & "/" & B4XSessions.UID)
	Log(" ")
	
	' Creates session cookie >>> Change domain and cookie folder values in B4XSession module before you run code <<<
	' Log("B4XSessions.SETSession - Creates session cookie on domain")
	' Log(" ")
	' B4XSessions.SETSession
	
	' Removes session cookie >>> Change domain and cookie folder values in B4XSession module before you run code <<<
	' Log("B4XSessions.UNSETSession - Removes session cookie on domain")
	' Log(" ")
	' B4XSessions.UNSETSession
	
	' Default Poststring POST request (pass a string) >>> Change domain and cookie folder values in B4XSession module before you run code <<<
	' log("B4XSessions.SendPostRequest("Hello B4X!") - Sets session through Poststring on domain")
	' Log(" ")
	' B4XSessions.SendPostRequest("Hello B4X!")

	Log("B4XSession module:")
	Log("Make sure you use change domain.com to your own." & CRLF & "Also a custom cookie folder before you run code.")
	Log(" ")
	
End Sub

'You can see the list of page related events in the B4XPagesManager object. The event name is B4XPage.

Private Sub btnGenerateUID_Click
	xui.MsgboxAsync(B4XSessions.GenerateUID(SessionUID),"B4XSessions.UID" & CRLF & CRLF & " - Generated User ID as a string")
End Sub

Private Sub btnDomainPath_Click
	xui.MsgboxAsync(B4XSessions.Domain(DomainPath),"B4XSessions.Domain" & CRLF & CRLF & " - Session cookies domain path")
End Sub

Private Sub btnDomainPathSession_Click
	xui.MsgboxAsync(B4XSessions.Domain(DomainPath) & "/" & B4XSessions.CookieFolder & "/" & B4XSessions.UID, "B4XSessions.Domain,B4XSessions.CookieFolder,B4XSessions.UID")' & CRLF & CRLF & " - Domain path to session cookie")
End Sub

Private Sub btnCreateSession_Click
	xui.MsgboxAsync(B4XSessions.Domain(DomainPath) & "/" & B4XSessions.CookieFolder & "/" & B4XSessions.UID,"B4XSessions.SETSession" & CRLF & CRLF & " - Creates a cookie on the domain")
	B4XSessions.SETSession
End Sub

Private Sub btnRemoveSession_Click
	xui.MsgboxAsync(B4XSessions.Domain(DomainPath) & "/" & B4XSessions.CookieFolder & "/" & B4XSessions.UID,"B4XSessions.UNSETSession" & CRLF & CRLF & " - Removes a cookie on the domain")
	B4XSessions.UNSETSession
End Sub

Private Sub btnCheckSession_Click
	xui.MsgboxAsync(B4XSessions.Domain(DomainPath) & "/" & B4XSessions.CookieFolder & "/" & B4XSessions.UID,"B4XSessions.CHECKSession" & CRLF & CRLF & " - Checkis if a cookie exists on the domain")
	B4XSessions.CHECKSession
	
End Sub

Private Sub btnSendPostRequest_Click
	xui.MsgboxAsync(B4XSessions.Domain(DomainPath) & "/" & B4XSessions.CookieFolder & "/" & B4XSessions.UID,"B4XSessions.SendPostRequest(String)" & CRLF & CRLF & " - Sets a session on the domain")
	B4XSessions.SendPostRequest("Hello B4X!")
End Sub